﻿namespace Otaku.Virtual.Users
{
    using Otaku;
    using Otaku.Managers;
    using Otaku.Virtual.Rooms;
    using System;
    using System.Runtime.CompilerServices;

    public class virtualRoomUser
    {
        internal int _tradePartnerRoomUID = -1;
        internal int gamePoints;
        internal int goalX;
        internal int goalY;
        internal double H;
        internal bool hasVoted;
        internal bool isTyping;
        internal bool petTransform;
        internal int roomID;
        internal int roomUID;
        internal bool SPECIAL_TELEPORTABLE;
        internal virtualRoomUserStatusManager statusManager;
        internal string swimOutfit;
        internal string SwimOutfit;
        internal virtualUser User;
        internal int userID;
        internal bool walkDoor;
        internal bool walkLock;
        internal int X;
        internal int Y;
        internal byte Z1;
        internal byte Z2;

        internal virtualRoomUser(int userID, int roomID, int roomUID, virtualUser User, virtualRoomUserStatusManager statusManager)
        {
            this.userID = userID;
            this.roomID = roomID;
            this.roomUID = roomUID;
            this.User = User;
            this.statusManager = statusManager;
        }

        internal void Refresh()
        {
            this.Room.Refresh(this);
        }

        internal string detailsString
        {
            get
            {
                string str = "";
                string str2 = this.User._Figure;
                if (this.petTransform)
                {
                    str = "7ui1\x0004";
                    str2 = "1 004 98A1C5";
                }
                string str3 = string.Concat(new object[] { 
                    "i:", this.roomUID, Convert.ToChar(13), "a:", this.userID, Convert.ToChar(13), "n:", str, this.User._Username, Convert.ToChar(13), "f:", str2, Convert.ToChar(13), "l:", this.X, " ", 
                    this.Y, " ", this.H, Convert.ToChar(13)
                 });
                if (this.User._Mission != "")
                {
                    object obj2 = str3;
                    str3 = string.Concat(new object[] { obj2, "c:", this.User._Mission, Convert.ToChar(13) });
                }
                string str4 = DB.runRead("SELECT badgeid FROM users_badges WHERE userid = '" + this.User.userID + "' AND iscurrent = '1'");
                string str5 = DB.runRead("SELECT badgeid FROM users_badges WHERE userid = '" + this.User.userID + "' AND iscurrent = '2'");
                string str6 = DB.runRead("SELECT badgeid FROM users_badges WHERE userid = '" + this.User.userID + "' AND iscurrent = '3'");
                string str7 = DB.runRead("SELECT badgeid FROM users_badges WHERE userid = '" + this.User.userID + "' AND iscurrent = '4'");
                string str8 = DB.runRead("SELECT badgeid FROM users_badges WHERE userid = '" + this.User.userID + "' AND iscurrent = '5'");
                if ((str4 + str5 + str6 + str7 + str8) != "")
                {
                    str3 = str3 + "b:";
                    if (str4 != "")
                    {
                        str3 = str3 + "1:" + str4;
                    }
                    if (str5 != "")
                    {
                        str3 = str3 + ",2:" + str5;
                    }
                    if (str6 != "")
                    {
                        str3 = str3 + ",3:" + str6;
                    }
                    if (str7 != "")
                    {
                        str3 = str3 + ",4:" + str7;
                    }
                    if (str8 != "")
                    {
                        str3 = str3 + ",5:" + str8;
                    }
                    str3 = str3 + ":";
                }
                if (this.SwimOutfit != "")
                {
                    object obj3 = str3;
                    str3 = string.Concat(new object[] { obj3, "p:", this.SwimOutfit, Convert.ToChar(13) });
                }
                if (this.User._groupID > 0)
                {
                    object obj4 = str3;
                    str3 = string.Concat(new object[] { obj4, "g:", this.User._groupID, Convert.ToChar(13), "t:", this.User._groupMemberRank, Convert.ToChar(13) });
                }
                return str3;
            }
        }

        internal virtualRoom Room
        {
            get
            {
                return roomManager.getRoom(this.roomID);
            }
        }

        internal string statusString
        {
            get
            {
                return string.Concat(new object[] { this.roomUID, " ", this.X, ",", this.Y, ",", this.H.ToString().Replace(",", "."), ",", this.Z1, ",", this.Z2, "/", this.statusManager.ToString() });
            }
        }

        private delegate void walkSleepPointer();
    }
}

