﻿namespace Otaku.Virtual.Rooms.Pathfinding
{
    using System;

    public sealed class gamePathfinder
    {
        public static Coord getNextStep(int X, int Y, int goalX, int goalY)
        {
            Coord coord = new Coord(-1, -1);
            if ((X > goalX) && (Y > goalY))
            {
                return new Coord(X - 1, Y - 1);
            }
            if ((X < goalX) && (Y < goalY))
            {
                return new Coord(X + 1, Y + 1);
            }
            if ((X > goalX) && (Y < goalY))
            {
                return new Coord(X - 1, Y + 1);
            }
            if ((X < goalX) && (Y > goalY))
            {
                return new Coord(X + 1, Y - 1);
            }
            if (X > goalX)
            {
                return new Coord(X - 1, Y);
            }
            if (X < goalX)
            {
                return new Coord(X + 1, Y);
            }
            if (Y < goalY)
            {
                return new Coord(X, Y + 1);
            }
            if (Y > goalY)
            {
                coord = new Coord(X, Y - 1);
            }
            return coord;
        }
    }
}

